/*-
 * ~~~~~~licensing~~~~~~
 * permission-component
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.permission.component.operation;


import org.apache.camel.Exchange;
import org.osgi.framework.FrameworkUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.system.common.osgi.OSGIUtils;
import ru.entaxy.esb.system.core.permission.component.PermissionEndpoint;
import ru.entaxy.esb.system.core.permission.component.PermissionProducer;
import ru.entaxy.esb.system.core.permission.jpa.PermissionService;
import ru.entaxy.esb.system.jpa.SystemService;

public abstract class BaseOperation implements Operation {

    private static final Logger LOG = LoggerFactory.getLogger(BaseOperation.class);

    private PermissionService permissionService;

    private SystemService systemService;

    @Override
    public void process(Exchange exchange, PermissionEndpoint endpoint) throws Exception {
        doProcess(exchange, endpoint);
    }

    protected abstract void doProcess(Exchange exchange, PermissionEndpoint endpoint) throws Exception;

    protected void validateParams(String... parameters) {
        for (String parameter : parameters) {
            if (parameter == null || "0".equals(parameter) || parameter.isEmpty()) {
                throw new IllegalArgumentException("One or more parameters empty!");
            }
        }
    }

    protected PermissionService getPermissionService() {
        if (permissionService == null) {
            permissionService = (PermissionService) OSGIUtils.getServiceReference(
                    FrameworkUtil.getBundle(PermissionProducer.class).getBundleContext(),
                    PermissionService.class.getName());
        }
        return permissionService;
    }

    protected SystemService getSystemService() {
        if (systemService == null) {
            systemService = (SystemService) OSGIUtils.getServiceReference(
                    FrameworkUtil.getBundle(PermissionProducer.class).getBundleContext(),
                    SystemService.class.getName());
        }
        return systemService;
    }

}
